<?php
/*
 *  Jirafeau, your web file repository
 *  Copyright (C) 2008  Julien "axolotl" BERNARD <axolotl@magieeternelle.org>
 *  Copyright (C) 2015  Jerome Jutteau <jerome@jutteau.fr>
 *  Copyright (C) 2024  Jirafeau project <https://gitlab.com/jirafeau> (see AUTHORS.md)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as
 *  published by the Free Software Foundation, either version 3 of the
 *  License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
session_start();
define('JIRAFEAU_ROOT', dirname(__FILE__) . '/');

require(JIRAFEAU_ROOT . 'lib/settings.php');
require(JIRAFEAU_ROOT . 'lib/functions.php');
require(JIRAFEAU_ROOT . 'lib/lang.php');

$download_pass = null;

if ($cfg['download_password_requirement'] === 'generated') {
    $download_pass = jirafeau_gen_download_pass($cfg['download_password_gen_len'], $cfg['download_password_gen_chars']);
}

check_errors($cfg);
if (has_error()) {
    require(JIRAFEAU_ROOT . 'lib/template/header.php');
    show_errors();
    require(JIRAFEAU_ROOT . 'lib/template/footer.php');
    exit;
}
require(JIRAFEAU_ROOT . 'lib/template/header.php');

// Logout action
if (isset($_POST['action']) && (strcmp($_POST['action'], 'logout') == 0)) {
    jirafeau_session_end();
}

/* Check if user is allowed to upload. */
// First check: Is user already logged
if (jirafeau_user_session_logged()) {
}
// Second check: Challenge by IP NO PASSWORD
elseif (true === jirafeau_challenge_upload_ip_without_password($cfg, get_ip_address($cfg))) {
    jirafeau_user_session_start();
    $_SESSION['user_auth_type'] = JIRAFEAU_USER_AUTH_BY_IP_NO_PASSWORD;
}
// Third check: Challenge by IP
elseif (true === jirafeau_challenge_upload_ip($cfg, get_ip_address($cfg))) {
    // Is an upload password required?
    if (jirafeau_has_upload_password($cfg)) {
        // Challenge by password
        if (isset($_POST['upload_password'])) {
            if (jirafeau_challenge_upload_password($cfg, $_POST['upload_password'])) {
                jirafeau_user_session_start();
                $_SESSION['user_auth_type'] = JIRAFEAU_USER_AUTH_BY_PASSWORD;
            } else {
                jirafeau_session_end();
                jirafeau_fatal_error(t('BAD_PSW'), $cfg);
            }
        }

        // Show login form if user session is not authorized yet
        if (!jirafeau_user_session_logged()) {
            ?>
            <form method="post" class="form login">
            <fieldset>
                <table>
                <tr>
                    <td class = "label"><label for = "enter_password">
                    <?php echo t('UP_PSW') . ':'; ?></label>
                    </td>
                </tr><tr>
                    <td class = "field"><input type = "password"
                    name = "upload_password" id = "upload_password"
                    size = "40" autocomplete = "current-password" />
                    </td>
                </tr>
                <tr class = "nav">
                    <td class = "nav next">
                    <input type = "submit" name = "key" value = "<?php echo t('LOGIN'); ?>" />
                    </td>
                </tr>
                </table>
            </fieldset>
            </form>
            <?php
            require(JIRAFEAU_ROOT.'lib/template/footer.php');
            exit;
        }
    }
} else {
    jirafeau_fatal_error(t('ACCESS_KO'), $cfg);
}

?>

<?php jirafeau_create_upload_finished_box($cfg['preview'], $download_pass); ?>

<div id="uploading">
    <p>
    <?php echo t('UP'); ?>
    <div id="uploaded_percentage"></div>
    <div id="uploaded_speed"></div>
    <div id="uploaded_time"></div>
    </p>
</div>

<div id="error_pop" class="error">
</div>

<div id="upload">
<form id="upload-form" onsubmit="
            event.preventDefault();
            document.getElementById('upload').style.display = 'none';
            document.getElementById('uploading').style.display = '';
            upload (<?php echo jirafeau_get_max_upload_chunk_size_bytes($cfg['max_upload_chunk_size_bytes']); ?>);
            "><fieldset>
    <legend>
    <?php echo t('SEL_FILE'); ?>
    </legend>
    <p>
        <input type="file" id="file_select" size="30"
    onchange="control_selected_file_size(<?php echo $cfg['maximal_upload_size'] ?>, '<?php
            if ($cfg['maximal_upload_size'] >= 1024) {
                echo t('2_BIG') . ', ' . t('FILE_LIM') . " " . number_format($cfg['maximal_upload_size'] / 1024, 2) . " GB.";
            } elseif ($cfg['maximal_upload_size'] > 0) {
                echo t('2_BIG') . ', ' . t('FILE_LIM') . " " . $cfg['maximal_upload_size'] . " MB.";
            }
?>')"/>
    </p>

    <div id="options">
        <table id="option_table">
        <?php
        if ($cfg['one_time_download']) {
            echo '<tr><td>' . t('ONE_TIME_DL') . ':</td>';
            echo '<td><input type="checkbox" id="one_time_download"';

            if ($cfg['one_time_download_preselected']) {
                echo ' checked';
            }

            echo ' /></td></tr>';
        }
if ($cfg['download_password_requirement'] === 'generated') {
    echo '<input type="hidden" name="key" id="input_key" value="' . $download_pass .'"/>';
} else {
    echo '<tr><td><label for="input_key">' . t('PSW') . ':' . '</label></td>';
    echo '<td class="passwordcolumn"><input type="password" name="key" id="input_key" autocomplete = "new-password"';
    if ($cfg['download_password_policy'] === 'regex') {
        echo ' pattern="' . substr($cfg['download_password_policy_regex'], 1, strlen($cfg['download_password_policy_regex']) - 2) . '"'; //remove php delimiters
    }
    if ($cfg['download_password_requirement'] === 'required') {
        echo ' required';
    }
    echo ' /> <button data-toggle="false" type="button" id="show_password">
    </button>';
    echo '</td></tr>';
}?>
        <tr>
        <td><label for="select_time"><?php echo t('TIME_LIM') . ':'; ?></label></td>
        <td>
            <?php jirafeau_create_selection_array($cfg); ?> 
        </td>
        </tr>

        <?php
if ($cfg['maximal_upload_size'] >= 1024) {
    echo '<p class="config">' . t('FILE_LIM');
    echo " " . number_format($cfg['maximal_upload_size'] / 1024, 2) . " GB.</p>";
} elseif ($cfg['maximal_upload_size'] > 0) {
    echo '<p class="config">' . t('FILE_LIM');
    echo " " . $cfg['maximal_upload_size'] . " MB.</p>";
} else {
    echo '<p class="config"></p>';
}
?>

        <p id="max_file_size" class="config"></p>
    <p>
    <input type="submit" id="send" value="<?php echo t('SEND'); ?>"/>
    </p>
        </table>
    </div> </fieldset></form>

    <?php
    if (jirafeau_user_session_logged() && $_SESSION['user_auth_type'] == JIRAFEAU_USER_AUTH_BY_PASSWORD) {
        ?>
    <form method="post" class="form logout">
        <input type = "hidden" name = "action" value = "logout"/>
        <input type = "submit" value = "<?php echo t('LOGOUT'); ?>" />
    </form>
    <?php
    }
?>

</div>

<script type="text/javascript" lang="Javascript">
// @license magnet:?xt=urn:btih:0b31508aeb0634b347b8270c7bee4d411b5d4109&dn=agpl-3.0.txt AGPL-v3-or-Later
    // ICONS in SVG
    const EYE_OPEN = `<svg width="20" height="20" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" aria-hidden="true" version="1.1" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
 <path d="m1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z" stroke-width="1.7604"/>
 <circle cx="12" cy="12" r="3"/>
 <path d="m2.9757 2.7901 18.56 18.546" display="none" fill="none" stroke="#000" stroke-width="1.7604"/>
</svg>`;
    const EYE_CLOSE = `<svg width="20" height="20" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" aria-hidden="true" version="1.1" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
 <path d="m1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z" stroke-width="1.7604"/>
 <circle cx="12" cy="12" r="3"/>
 <path d="m2.9757 2.7901 18.56 18.546" fill="none" stroke="#000" stroke-width="1.7604"/>
</svg>`;



    document.getElementById('error_pop').style.display = 'none';
    document.getElementById('uploading').style.display = 'none';
    document.getElementById('upload_finished').style.display = 'none';
    document.getElementById('options').style.display = 'none';
    document.getElementById('send').style.display = 'none';
    if (!check_html5_file_api ())
        document.getElementById('max_file_size').innerHTML = '<?php
        $max_size = jirafeau_get_max_upload_size();
if ($max_size > 0) {
    echo t('NO_BROWSER_SUPPORT') . $max_size;
}
?>';

    addCopyListener('upload_link_button', 'upload_link');
    addCopyListener('preview_link_button', 'preview_link');
    addCopyListener('direct_link_button', 'direct_link');
    addCopyListener('delete_link_button', 'delete_link');
    addTextCopyListener('password_copy_button', 'output_key');
// @license-end
// show password toggle
    document.getElementById('show_password').innerHTML = EYE_OPEN;
    document.getElementById('show_password')?.addEventListener('click', function() {
        const pwd = document.getElementById('input_key');
        const show_password = pwd.type === 'text';
        const next_show_password_toggle_value  = !show_password;
        if (next_show_password_toggle_value) {
            pwd.type = 'text';
            document.getElementById('show_password').setAttribute('data-show-enabled', true);
            // symbol eye strikethrough
            document.getElementById('show_password').innerHTML = EYE_CLOSE;
        } else {
            pwd.type = 'password';
            // symbol eye 
            document.getElementById('show_password').innerHTML = EYE_OPEN;
        }
    });
</script>
<?php require(JIRAFEAU_ROOT . 'lib/template/footer.php'); ?>
